/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.47 by adcroft, Tue Nov 25 14:57:45 2003 UTC revision 1.68 by adcroft, Tue Feb 24 19:14:18 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
86            
# Line 138  EOF Line 145  EOF
145          echo "   "$p_FC          echo "   "$p_FC
146          if test "x$FC" = x ; then          if test "x$FC" = x ; then
147              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
148                echo "  Setting FORTRAN compiler to: "$FC
149          fi          fi
150      fi      fi
151    
152      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
153          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
154          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
155              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
156              echo "  The options file:  $p_OF"          fi
157              echo "    appears to match so we'll use it."      fi
158              break  #    echo "  The options file:  $p_OF"
159          fi  #    echo "    appears to match so we'll use it."
160      done  #   for i in $p_FC ; do
161    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
162    #if test -r $p_OF ; then
163    #    OPTFILE=$p_OF
164    #    echo "  The options file:  $p_OF"
165    #    echo "    appears to match so we'll use it."
166    #    break
167    #fi
168    #   done
169      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
170          cat 1>&2 <<EOF          cat 1>&2 <<EOF
171    
# Line 287  Usage: "$0" [OPTIONS] Line 303  Usage: "$0" [OPTIONS]
303            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
304            is being used.            is being used.
305    
306        -mpi | --mpi
307              Include MPI header files and link to MPI libraries
308        -mpi=PATH | --mpi=PATH
309              Include MPI header files and link to MPI libraries using MPI_ROOT
310              set to PATH. i.e. Include files from $PATH/include, link to libraries
311              from $PATH/lib and use binaries from $PATH/bin.
312    
313    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
314    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
315    
# Line 430  EOF Line 453  EOF
453  }  }
454    
455    
456    check_netcdf_libs()  {
457        cat <<EOF > genmake_tnc.F
458          program fgennc
459    #include "netcdf.inc"
460          integer iret, ncid, xid
461          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
462          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
463          iret = nf_def_dim(ncid, 'X', 11, xid)
464          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
465          iret = nf_close(ncid)
466          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
467          end
468    EOF
469        $CPP genmake_tnc.F > genmake_tnc.f  \
470            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
471        RET_COMPILE=$?
472        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
473        RETVAL=$?
474        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
475            HAVE_NETCDF=t
476        else
477            # try again with "-lnetcdf" added to the libs
478            $CPP genmake_tnc.F > genmake_tnc.f  \
479                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
480                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
481            RET_COMPILE=$?
482            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
483            RETVAL=$?
484            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
485                LIBS="$LIBS -lnetcdf"
486                HAVE_NETCDF=t
487            else
488                cat genmake_tnc.log >> genmake_warnings
489            fi
490        fi
491        rm -f genmake_tnc*
492    }
493    
494    
495    
496    ###############################################################################
497    #   Sequential part of script starts here
498    ###############################################################################
499    
500  #  Set defaults here  #  Set defaults here
501  COMMANDL="$0 $@"  COMMANDL="$0 $@"
502    
# Line 438  LN= Line 505  LN=
505  S64=  S64=
506  KPP=  KPP=
507  FC=  FC=
508    CPP=
509  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
510  DEFINES=  DEFINES=
511  PACKAGES=  PACKAGES=
512  ENABLE=  ENABLE=
# Line 460  LIBS= Line 527  LIBS=
527  KPPFILES=  KPPFILES=
528  NOOPTFILES=  NOOPTFILES=
529  NOOPTFLAGS=  NOOPTFLAGS=
530    MPI=
531    MPIPATH=
532    
533  # DEFINES checked by test compilation  # DEFINES checked by test compilation
534  HAVE_SYSTEM=  HAVE_SYSTEM=
535  HAVE_FDATE=  HAVE_FDATE=
536  FC_NAMEMANGLE=  FC_NAMEMANGLE=
537  HAVE_CLOC=  HAVE_CLOC=
538    HAVE_NETCDF=
539    
540  MODS=  MODS=
541  TOOLSDIR=  TOOLSDIR=
542  SOURCEDIRS=  SOURCEDIRS=
543  INCLUDEDIRS=  INCLUDEDIRS=
544  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
545    
546  PWD=`pwd`  PWD=`pwd`
547  MAKE=make  MAKE=make
# Line 505  TAMC_EXTRA= Line 575  TAMC_EXTRA=
575    
576  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
577  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
578  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
579    
580  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
581  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 586  for ac_option ; do Line 656  for ac_option ; do
656          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
657              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
658                    
659          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
660              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
661          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
662              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 657  for ac_option ; do Line 727  for ac_option ; do
727              IEEE=true ;;              IEEE=true ;;
728          -noieee | --noieee)          -noieee | --noieee)
729              IEEE= ;;              IEEE= ;;
730    
731            -mpi | --mpi)
732                MPI=true ;;
733            -mpi=* | --mpi=*)
734                MPIPATH=$ac_optarg
735                MPI=true ;;
736                    
737  #       -jam | --jam)  #       -jam | --jam)
738  #           JAM=1 ;;  #           JAM=1 ;;
# Line 798  fi Line 874  fi
874  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
875      LINK=$FC      LINK=$FC
876  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
877  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
878      MAKE="make"      MAKE="make"
879  fi  fi
880    if test "x$CPP" = x ; then
881        CPP=cpp
882    fi
883    #EH3 === UGLY ===
884    #  The following an ugly little hack to check for $CPP in /lib/ and it
885    #  should eventually be replaced with a more general function that
886    #  searches a combo of the user's path and a list of "usual suspects"
887    #  to find the correct location for binaries such as $CPP.
888    for i in " " "/lib/" ; do
889        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
890    done
891    #EH3 === UGLY ===
892  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
893  RETVAL=$?  RETVAL=$?
894  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 840  EOF Line 925  EOF
925  fi  fi
926  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
927    
928    if test ! "x$MPI" = x ; then
929          echo "  Turning on MPI cpp macros"
930          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
931    fi
932    
933  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
934  echo -n "  Do we have the system() command using $FC...  "  echo -n "  Do we have the system() command using $FC...  "
# Line 888  if test "x$HAVE_CLOC" != x ; then Line 977  if test "x$HAVE_CLOC" != x ; then
977  else  else
978      echo "no"      echo "no"
979  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
980  rm -f genmake_t*  rm -f genmake_t*
981    
982    echo -n "  Can we create NetCDF-enabled binaries...  "
983    check_netcdf_libs
984    if test "x$HAVE_NETCDF" != x ; then
985        echo "yes"
986    else
987        echo "no"
988    fi
989    
990    
991  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
992  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
# Line 935  if test "x${TOOLSDIR}" = x ; then Line 1026  if test "x${TOOLSDIR}" = x ; then
1026      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1027  fi  fi
1028  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1029      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1030      exit 1      exit 1
1031  fi  fi
1032  if test "x$S64" = x ; then  if test "x$S64" = x ; then
# Line 956  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1047  if test -r $ROOTDIR"/eesupp/src/Makefile
1047          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1048      else      else
1049          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1050          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1051          exit 1          exit 1
1052      fi      fi
1053  fi  fi
1054    
1055    #same for exch2
1056    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1057        echo "  Making source files in exch2 from  templates"
1058        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1059        RETVAL=$?
1060        if test "x${RETVAL}" = x0 ; then
1061            rm -f make_exch2.errors
1062        else
1063            echo "Error: problem encountered while building source files in exch2:"
1064            cat make_exch2.errors 1>&2
1065            exit 1
1066        fi
1067    fi
1068    
1069  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1070  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1071      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1144  for i in $PACKAGES ; do Line 1249  for i in $PACKAGES ; do
1249      fi      fi
1250  done  done
1251    
1252    #  Build MNC templates and check for ability to build and use NetCDF
1253    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1254    RETVAL=$?
1255    if test "x$RETVAL" = x0 ; then
1256        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1257        RETVAL=$?
1258        if test "x${RETVAL}" = x0 ; then
1259            rm -f make_mnc.errors
1260        else
1261            echo "Error: problem encountered while building source files in pkg/mnc:"
1262            cat make_mnc.errors 1>&2
1263            exit 1
1264        fi
1265        if test "x$HAVE_NETCDF" != xt ; then
1266            cat <<EOF
1267    
1268    WARNING: the "mnc" package has been enabled but tests failed to
1269      compile and/or execute NetCDF applications.  Please check that:
1270    
1271      1) NetCDF is installed for your compiler and
1272      2) the LIBS variable (within the 'optfile") specifies the correct
1273           NetCDF library to link against.
1274      
1275    EOF
1276        fi
1277    fi
1278    
1279  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
1280  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
# Line 1178  for i in $PACKAGES ; do Line 1309  for i in $PACKAGES ; do
1309  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1310      case $i in      case $i in
1311          aim_v23)          aim_v23)
             DEFINES="$DEFINES -DALLOW_AIM"  
1312              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1313              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
1314              ;;              ;;
1315      esac      esac
1316  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
# Line 1189  done Line 1319  done
1319    
1320  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1321  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1322  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1323      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1324  fi  fi
1325  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1326      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1327      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1328          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1329          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1330          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1331      else              exit 1
1332          SOURCEDIRS="$SOURCEDIRS $adr"          else
1333      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1334      adr="$ROOTDIR/$d/inc"          fi
1335      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1336          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1337          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1338          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1339      else              exit 1
1340          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1341      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1342  done          fi
1343        done
1344    fi
1345    
1346  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1347  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1348  CPP_OPTIONS=  CPP_OPTIONS=
1349    CPP_EEOPTIONS=
1350  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1351    names=`ls -1 "$ROOTDIR/pkg"`
1352  for i in $spaths ; do  for i in $spaths ; do
1353      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1354      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1355          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1356          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1357          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1358            for n in $names ; do
1359                test_for_package_in_cpp_options $CPP_OPTIONS $n
1360            done
1361        fi
1362        try="$i/CPP_EEOPTIONS.h"
1363        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1364            echo "    found CPP_EEOPTIONS=\"$try\""
1365            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1366    #**** not yet enabled ****
1367    #        test_for_mpi_in_cpp_eeoptions $try
1368    #**** not yet enabled ****
1369            CPP_EEOPTIONS="$try"
1370      fi      fi
1371  done  done
1372  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1373      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1374      exit 1      exit 1
1375  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1376    
1377  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1378  #  compiler.  #  compiler.
# Line 1248  for i in $SOURCEDIRS ; do Line 1387  for i in $SOURCEDIRS ; do
1387      done      done
1388  done  done
1389    
1390    
1391  echo  echo
1392  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1393  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 1347  EXE_FTL=$EXECUTABLE"_ftl" Line 1487  EXE_FTL=$EXECUTABLE"_ftl"
1487  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1488    
1489  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1490    #
1491    # OPTFILE="$OPTFILE"
1492  #  #
1493  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1494  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1383  EXE_SVD     = ${EXE_SVD} Line 1525  EXE_SVD     = ${EXE_SVD}
1525  ENABLED_PACKAGES = ${ENABLED_PACKAGES}  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1526  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1527    
1528    # These files are created by Makefile
1529    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1530    
1531  EOF  EOF
1532    
1533  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1447  cat >>$MAKEFILE <<EOF Line 1592  cat >>$MAKEFILE <<EOF
1592  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1593    
1594  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1595  \$(EXECUTABLE): links \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1596          @echo Creating \$@ ...          @echo Creating \$@ ...
1597          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1598  depend:  depend:
# Line 1455  depend: Line 1600  depend:
1600          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1601          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1602    
1603  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) ${PACKAGES_DOT_H} AD_CONFIG.h  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1604    
1605  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1606    
# Line 1468  clean: Line 1613  clean:
1613  Clean:  Clean:
1614          @make clean          @make clean
1615          @make cleanlinks          @make cleanlinks
1616          -rm -f ${PACKAGES_DOT_H} AD_CONFIG.h          -rm -f \$(SPECIAL_FILES)
1617          -rm -f Makefile.bak genmake_state genmake_*optfile genmake_warnings make.log          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1618  CLEAN:  CLEAN:
1619          @make Clean          @make Clean
1620          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1483  makefile: Line 1628  makefile:
1628  cleanlinks:  cleanlinks:
1629          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1630    
1631  # Special targets  # Special targets ($SPECIAL_FILES) which are create by make
1632  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1633          @echo Creating \$@ ...          @echo Creating \$@ ...
1634          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1635  AD_CONFIG.h:  AD_CONFIG.h:
1636          @echo Creating \$@ ...          @echo Creating \$@ ...
1637          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1638    FC_NAMEMANGLE.h:
1639            @echo Creating \$@ ...
1640            echo "$FC_NAMEMANGLE" > \$@
1641    
1642  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1643  .F.f:  .F.f:
# Line 1549  adall: ad_taf Line 1697  adall: ad_taf
1697  adtaf: ad_taf_output.f  adtaf: ad_taf_output.f
1698  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1699    
1700  ad_input_code.f: links \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1701          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1702          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1703          -rm -f ad_config.template          -rm -f ad_config.template
# Line 1581  ftlall: ftl_taf Line 1729  ftlall: ftl_taf
1729  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.f
1730  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1731    
1732  ftl_input_code.f: links \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1733          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1734          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1735          -rm -f ftl_config.template          -rm -f ftl_config.template
# Line 1659  $TOOLSDIR/convert_cpp_cmd2defines "Warni Line 1807  $TOOLSDIR/convert_cpp_cmd2defines "Warni
1807  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
1808      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1809  else  else
1810      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1811      RETVAL=$?      RETVAL=$?
1812      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
1813          rm -f $PACKAGES_DOT_H".tmp"          rm -f $PACKAGES_DOT_H".tmp"

Legend:
Removed from v.1.47  
changed lines
  Added in v.1.68

  ViewVC Help
Powered by ViewVC 1.1.22